function cost_fn = utility_to_cost(utility_fn)
%UTILITY_TO_COST reverse sign on a function to maximize using MINIMIZE_ARGS
%
% Example usage, finding maximum of a utility function:
% cost_fn = utility_to_cost(utility_fn);
% [opt_arg1, opt_arg2, opt_value] = minimize_args(cost_fn, -100, arg1, arg2);
%
% See also: minimize_args, penalize_square, var_checkgrad

cost_fn = @(varargin) reverse_sign(utility_fn, varargin);


function varargout = reverse_sign(fn, args)

varargout = cell(length(args) + 1, 1);
[varargout{:}] = fn(args{:});
varargout = cellmap(@(x) -x, varargout);
